﻿IncludeFile "../DynLib.pb"

CompilerIf (#PB_Compiler_Processor = #PB_Processor_x86)
#LibName$ = "glfw3.x86.dll"
CompilerElse   
#LibName$ = "glfw3.x64.dll"
CompilerEndIf

#TEST_FILE = 0
#TEST_SYSTEMP = 1
#TEST_MEMORY = 2

#TEST_TYPE = #TEST_FILE ; select here what to test


CompilerIf #TEST_TYPE = #TEST_FILE
 reg = DynLib::RegisterFile(#LibName$)
CompilerEndIf

CompilerIf #TEST_TYPE = #TEST_SYSTEMP
DataSection
 glfw3:
 IncludeBinary #LibName$ 
 glfw3_end:
EndDataSection
 reg = DynLib::RegisterSysTemp(#LibName$, ?glfw3, ?glfw3_end)
CompilerEndIf

CompilerIf #TEST_TYPE = #TEST_MEMORY
DataSection
 glfw3:
 IncludeBinary #LibName$ 
 glfw3_end:
EndDataSection
 reg = DynLib::RegisterMemory(?glfw3, ?glfw3_end)
CompilerEndIf


If reg = 0
    Debug "Something went wrong with the library registration."
    End
EndIf


; the code below is the same for all modes

hglfw = DynLib::LoadLibrary(reg)

If hglfw         
    PrototypeC.i glfwInit() : Global glfwInit.glfwInit = DynLib::GetProcAddress(hglfw, "glfwInit")  
    PrototypeC.i glfwGetVersionString() : Global glfwGetVersionString.glfwGetVersionString = DynLib::GetProcAddress(hglfw, "glfwGetVersionString")
    
    Debug "glfwInit() = " + glfwInit()
    Debug "glfwGetVersionString() = " + PeekS(glfwGetVersionString(), -1, #PB_UTF8)
        
    DynLib::FreeLibrary(hglfw)    
EndIf

; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 12
; Folding = -
; EnableXP
; EnableUser
; CPU = 1
; CompileSourceDirectory
; EnablePurifier
; EnableExeConstant
; EnableUnicode